
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 *
 */

#ifndef DEFINE_DARRAY_H
#define DEFINE_DARRAy_H

class DArray
{
public:
	DArray (int asize = 0);
	~DArray ();

	bool add (char * VALUE);
	void drop ();
	char * get (int NUM);
	int get_size ();
	int set_size (int);
	inline char ** get_skeleton ()
	{
		return values;
	}
	void foreach (Dfunc_t);
	void set (long, char *);
	void init (int asize);
	bool from_file (char * __from);
	inline int get_real_size () {
		return size;
	}

private:
	char ** values;
	int size;
	int used;

};

#endif
