
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 *
 */

#ifndef DEFINE_ELIST_H
#define DEFINE_ELIST_H

class EList : public DList 
{
        public:
                EList ();
                ~EList ();

                char * get ();
                char * first ();
                char * last ();
                char * next ();
                char * prev ();
                char * rm ();
		bool eol ();
                inline char * del () {
                        return rm ();
                }
		inline char * add (const char *S) {
			return add_tail ((char *) S);
		}
		EList & operator << (char *);
                
        private:
                __dlist_entry_t * pos;
};

#endif

