
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2007
 * graycardinalster@gmail.com
 * 
 */

#ifndef DEFINE_TT_H
#define DEFINE_TT_H
class TT
{
	public:
		TT ();
		~TT ();
		
		int loadFile (char * fileName);
		int init ();
		int drop ();
		char * op ();
		char * nextOperator ();
		int wit ();

		inline int line () {
			if (! tt)
				return -1;
			return tt->attachment[ENV->t_op_no].pair_line + 1;
		}

		char ch;
		tt_state_t * tt;
		int bracketDepth;

	private:
		char *d_out, *d_ptr;
		int depthModif;
};

#endif

