
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006,2007
 * graycardinalster@gmail.com
 * 
 */ 

void nogui_tagsdump (char * f_name, int n_trip) ;
void opMacro (char ** d_ptr, char ** d_out, char ch) ;
int ww_begin_line (struct tt_state_t * d_tt_state, char *d_out, int d_offset) ;
char * ww_begin_offset (struct tt_state_t * d_tt_state, char *d_out, int d_offset) ;

#include <inline.h>

/* sblib */
bool def_test (char * d_op) ;
int what_is_this (char * d_op, char ch) ;
char * sstrend (char * d_ptr) ;
void free_cword (c_word * S) ;
inline struct c_word * new_cword (char *word, char sym) ;
DArray * split_to_words (char * d_op) ;
char * cts (struct c_word * d_word) ;
char * ww_last_word (char *d_op) ;
char * ruby_last_word (char * op) ;
int words_count (char *S) ;
struct tt_state_t * get_onett_tag (char * f_name, char ** d_tt_buf) ;
int sblib_find (const char * path, const char * name, const char * f_outname) ;
int find_cfiles () ;
int split_tmp_files () ;
int remove_tmp_files () ;
EHash * bob_init_compile_env () ;
void setParam (char *opt) ;
char * name2obj (char * name) ;
void globalsPrint (tt_state_t * tt, char * d_out, int d_found_type) ;
bool validOption (char *Name) ;
int newPluginID () ;
/**/

/*** ./call_tags.cxx ***/
void call_tags_main (tt_state_t * d_tt_state, DArray * dout) ;
int call_tags (EArray * d_files) ;
int callTagsFile (char * fileName) ;

/*** ./cgrep.cxx ***/
namespace cgrep {
	int file (tt_state_t * d_tt_state) ;
	int cgrep (EArray * d_files) ;
}

/*** ./flist.cxx ***/
char * flist_iter (char * d_ptr, char * d_name, bool b_repair) ;
void flist_main (char * d_file) ;

/*** ./globals.cxx ***/
void globals_main (struct tt_state_t * d_tt_state, int d_type) ;
void bob_globals (char * d_file, int d_type) ;

/*** ./kinds.cxx ***/
int kindsFile (char * fileName, int type) ;

/*** ./got_structs.cxx ***/
void got_structs (char * d_file) ;

/*** ./got_tag.cxx ***/
int parse_regexp (char * d_file, char * S) ;
bool bob_tag (char *d_str, char * d_name, d_tag_t * d_tag) ;
EArray * got_tag (char * d_tag) ;

/*** ./init.cxx ***/
int sb_init () ;

/*** ./main.cxx ***/
int sb_prname (char *arg) ;
int main (int argc, char ** argv) ;

/*** ./make_tags.cxx ***/
void mk_tags (char *f_name, DArray *d_in) ;
void make_ctags (EArray * d_files) ;

/*** ./mk_tag.cxx ***/
char * macro_name (char * d_op, char * d_macro_name) ;
void mk_tag_macro (char * d_op, char * d_file, int t_line) ;
void mk_tag (char * d_op, char * d_file, int line, int d_found_type) ;
DArray * mk_tag_structtail_split (char *S) ;
void mk_tag_structtail (char * S, char * d_file, int t_line) ;

/*** ./modding.cxx ***/
env_t * sb_getenv (void) ;
char modding_optparse (int * i, int step) ;
int linux_modding_init () ;
void mods_short_info ();

/*** ./nogui_fdump.cxx ***/
bool brace_count (char * d_str, int * d_count, bool b_force_block) ;
void nogui_fdump (struct fdump_param_t * d_param) ;

/*** ./nogui_indent.cxx ***/
void nogui_indent () ;

/*** ./tags.cxx ***/
void tags (DArray * d_names, char * d_file_output) ;

/*** ./interactive.cxx ***/
void tags_interactive () ;

/*** ./t_op.cxx ***/
char t_op (char ** d_in, char ** d_prev, bool b_no_operators = true) ;

/*** ./tree.cxx ***/
inline bool tree_immune (char * m_fname) ;
void rctree_iter (char * f_name, int n_trip) ;
void reverse_calltree (char * f_name) ;
void tree_echo (int n_trip, char *S) ;
inline void tree_mkpos (int N) ;
void call_tree (char * f_name, int n_trip) ;

/*** ./usage.cxx ***/
void usage () ;

int opts_kinds (DArray * d_opts, int & i) ;
int opts_settings (DArray * d_opts, int & i) ;
int opts_funcs (DArray * d_opts, int & i) ;

/*** ./sb_prnmame.cxx **/
int sb_prname (char *arg) ;

int bob_cfiles ();
int logToFile (char * fileName, char * fmt, ...);

