
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 * 
 */ 

#ifndef DEFINE_ENV_H
#define DEFINE_ENV_H

struct env_t
{
	EArray * d_tags_file; // tags array
	EArray * immune_list;
	EArray * full_list;
	EArray * modding;
	EArray * d_cops;
	DArray * d_opts;
	EArray * d_files;
	DJobs * proc_list;
	EHash * settings;
	EList * listOptions; // available options
	
	FILE *d_stream_dbg;
	
	char * home_dir;
	char * tmp_files;
	char * tmp_tags;
	char * debug_file;
	char * home_plugins;
	char * shared_plugins;
	char * language;
	char * cgrep_exp;

	int t_op_no;
	int d_depth;
	int cgrep_A;
	int cgrep_B;
	int sb_cmd;
	int max_proc;
	int nproc;
	int d_kinds;
	uint32_t sb_flags;
};

extern "C" struct env_t *ENV;
extern "C" struct env_t *get_env ();
#endif
