
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 * 
 */ 

#ifndef DEFINE_WIT_H
#define DEFINE_WIT_H

namespace OT {
	enum  {
		Variable = 1<<0,
		Typedef = 1<<1,
		Extern = 1<<2,
		Function = 1<<3,
		Struct = 1<<4,
		Operator = 1<<5,
		Macro = 1<<6,
		Call = 1<<7,
		Define = 1<<8,
		Class = 1<<9,
		Namespace = 1<<10,
		Enum = 1<<11,
		Other = 1<<30
	};
};

#endif
